// Copyright (c) Renewed Vision, LLC. All rights reserved.

uniform sampler2DRect texUnitY;
uniform float cosHue;
uniform float sinHue;
uniform float contrast;
uniform float saturation;
uniform float brightness;
const vec4 stdbias = vec4(-0.5  , -0.0625,  -0.5   ,0.0  );

void main()
{
    float isOddLine;
    float isOddUV;
    vec2 tc00;
    vec2 tc10;
    vec2 tc20;
    vec4 c00;
    vec4 c10;
    vec4 c20;
    vec4 avg;
    
    tc10=gl_TexCoord[0].xy;
    
    isOddLine=floor(fract(tc10.y * 0.5) * 2.0);
    isOddUV = floor(fract(tc10.x * 0.5) * 2.0);
    tc10.x*=.5;
    
    //above and below lines start with same coordinates
    tc00=tc10;
    tc20=tc10;
    //for above line, subtract 1
    tc00.y-=isOddLine;
    //for below line, add 1
    tc20.y+=isOddLine;
    
    c00 = texture2DRect(texUnitY, tc00);
    c10 = texture2DRect(texUnitY, tc10);
    c20 = texture2DRect(texUnitY, tc20);

    c00.g=mix(c00.g,c00.a,isOddUV);
    c10.g=mix(c10.g,c10.a,isOddUV);
    c20.g=mix(c20.g,c20.a,isOddUV);
    
    avg=(c00+c20)*0.5;

    if(c10.g>=c00.g)
    {
        if(c10.g>c20.g)
            c10=avg;
    }
    else
    {
        if(c10.g<c20.g)
            c10=avg;
    }
    c10+=stdbias;
    c00.g = (c10.g * contrast) + brightness;
    float tmp=contrast*saturation;
    c00.r = (c10.r * cosHue + c10.b * sinHue) * tmp;
    c00.b = (c10.b * cosHue - c10.r * sinHue) * tmp;
    c00-=stdbias;
    gl_FragColor=c00;
}
