// Copyright (c) Renewed Vision, LLC. All rights reserved.
// Fragment shader for interlacing two texture 'fields' into one texture frame

uniform sampler2DRect inputTex0;
uniform sampler2DRect inputTex1;
uniform float xInc;

void main()
{
    vec4 yuv0;
    vec4 yuv1;
    float isOddLine=0.0;
    vec4 c00;
    vec4 c10;
    
    vec2 tc0=gl_TexCoord[0].xy;
    vec2 tc1;
    
    tc1.x=tc0.x+xInc;
    tc1.y=tc0.y;
    
    yuv0 = texture2DRect(inputTex0, tc0);
    yuv1 = texture2DRect(inputTex0, tc1);

    c00=mix(yuv0,yuv1,.5);
    c00.a = yuv1.g;
    c00.g = yuv0.g;

    yuv0 = texture2DRect(inputTex1, tc0);
    yuv1 = texture2DRect(inputTex1, tc1);
    
    c10=mix(yuv0,yuv1,.5);
    c10.a = yuv1.g;
    c10.g = yuv0.g;

    isOddLine=floor(fract(gl_FragCoord.y * 0.5) * 2.0);
    gl_FragColor =mix(c00,c10,isOddLine);
}

