// Copyright (c) Renewed Vision, LLC. All rights reserved.
// Convert RGB to YUV2 using std 601

uniform sampler2DRect inputTex;
uniform sampler2DRect texUnit;
uniform float alpha;

const vec4 std601X = vec4(  0.299 ,  0.587,  0.114, 0.0  );
const vec4 std601Y = vec4( -0.169 , -0.331,  0.500, 0.0  );
const vec4 std601Z = vec4(  0.500 , -0.419, -0.081, 0.0  );

void main()
{
    vec4 texColor0;
    vec4 yuv0;
    vec4 white=vec4(.85,.85,.85,1.0);
    vec4 black=vec4(0,0,0,1);
    vec2 tc0=gl_TexCoord[0].xy;
    
    texColor0 = texture2DRect(inputTex, tc0);
    texColor0*=gl_Color;
    
    yuv0 = vec4(dot(std601X, texColor0),
                dot(std601Y, texColor0)+0.5,
                dot(std601Z, texColor0)+0.5,
                1.0 );
    
    gl_FragColor.a = texColor0.a;
    gl_FragColor.r = yuv0.b;
    gl_FragColor.b = yuv0.g;
    gl_FragColor.g = yuv0.r;
}
