// Copyright (c) Renewed Vision, LLC. All rights reserved.
// Convert (and horizontal downsample) RGB to YUV2 using std 601 (this seems to be what Blackmagic card likes)

uniform sampler2DRect inputTex;
uniform sampler2DRect texUnit;

const vec4 std601X = vec4(  0.299 ,  0.587,  0.114, 0.0  );
const vec4 std601Y = vec4( -0.169 , -0.331,  0.500, 0.0  );
const vec4 std601Z = vec4(  0.500 , -0.419, -0.081, 0.0  );

void main()
{
    vec4 texColor0;
    vec4 texColor1;
    vec4 yuv0;
    vec4 yuv1;
    vec2 tc0=gl_TexCoord[0].xy;
    vec2 tc1;
    
    tc0.x=tc0.x*2.0;
    tc1.x=tc0.x+1.0;
    tc1.y=tc0.y;
    
    texColor0 = texture2DRect(inputTex, tc0);
    texColor1 = texture2DRect(inputTex, tc1);
    
    yuv0 = vec4(dot(std601X, texColor0),
                dot(std601Y, texColor0)+0.5,
                dot(std601Z, texColor0)+0.5,
                1.0 );
    
    yuv1 = vec4(dot(std601X, texColor1),
                dot(std601Y, texColor1)+0.5,
                dot(std601Z, texColor1)+0.5,
                1.0 );
    
    
    gl_FragColor.a = yuv1.r;
    gl_FragColor.r = (yuv0.b+yuv1.b)*.5;
    gl_FragColor.b = (yuv0.g+yuv1.g)*.5;
    
    gl_FragColor.g = yuv0.r;
}
