// Copyright (c) Renewed Vision, LLC. All rights reserved.
// Convert (and downsample) RGB to YUV2 using std 709 (HD)

uniform sampler2DRect inputTex;
uniform sampler2DRect texUnit;

const vec4 std709X = vec4(  0.412 ,  0.358,  0.180, 0.0  );
const vec4 std709Y = vec4(  0.213 ,  0.715,  0.072, 0.0  );
const vec4 std709Z = vec4(  0.019 ,  0.119,  0.950, 0.0  );

void main()
{
    vec4 texColor0;
    vec4 texColor1;
    vec4 yuv0;
    vec4 yuv1;
    vec2 tc0=gl_TexCoord[0].xy;
    vec2 tc1;
    
    tc0.x=tc0.x*2.0;
    tc1.x=tc0.x+1.0;
    tc1.y=tc0.y;

    texColor0 = texture2DRect(inputTex, tc0);
    texColor1 = texture2DRect(inputTex, tc1);
    
    yuv0 = vec4(dot(std709X, texColor0),
                    dot(std709Y, texColor0)+0.5,
                    dot(std709Z, texColor0)+0.5,
                    1.0 );
    
    yuv1 = vec4(dot(std709X, texColor1),
                    dot(std709Y, texColor1)+0.5,
                    dot(std709Z, texColor1)+0.5,
                    1.0 );
 

    gl_FragColor.a = yuv1.r;
    gl_FragColor.r = (yuv0.b+yuv1.b)*.5;
    gl_FragColor.b = (yuv0.g+yuv1.g)*.5;

    gl_FragColor.g = yuv0.r;
}
