// Copyright (c) Renewed Vision, LLC. All rights reserved.

uniform sampler2DRect texUnitY;
uniform float cosHue;
uniform float sinHue;
uniform float contrast;
uniform float saturation;
uniform float brightness;

const vec4 stdbias = vec4(-0.5  , -0.0625,  -0.5   ,0.0  );

void main()
{
    vec4 y0;
    vec4 y1;
    vec2 tcY=gl_TexCoord[0].xy;
    float isOddUV;
    
    isOddUV = floor(fract(tcY.x * 0.5) * 2.0);
    tcY.x*=.5;

    y0 = texture2DRect(texUnitY, tcY);
    y1=y0;
    y1.g=y0.a;
    
    y0=mix(y0,y1,isOddUV);

    y0+=stdbias;
    y1.g = (y0.g * contrast) + brightness;
    float tmp=contrast*saturation;
    y1.r = (y0.r * cosHue + y0.b * sinHue) * tmp;
    y1.b = (y0.b * cosHue - y0.r * sinHue) * tmp;
    y1-=stdbias;
    
    gl_FragColor=y1;
}
