// Copyright (c) Renewed Vision, LLC. All rights reserved.

uniform sampler2DRect texUnitY;
uniform sampler2DRect texUnitU;
uniform sampler2DRect texUnitV;

void main()
{
    vec4 y0y1;
    vec4 u0u1;
    vec4 v0v1;
    vec4 outPixel;
    float isOddUV;
    vec2 tcY=gl_TexCoord[0].xy;
    vec2 tcUV=tcY;

    tcUV.x*=.25;
    
    isOddUV = floor(fract(tcY.x * 0.5) * 2.0);
    tcY.x*=.5;

    y0y1 = texture2DRect(texUnitY, tcY);
    u0u1 = texture2DRect(texUnitU, tcUV);
    v0v1 = texture2DRect(texUnitV, tcUV);

    if(isOddUV!=0.0)
    {
        outPixel.g=(y0y1.a*64.0)+(y0y1.r*.25);  //high byte shifted up 6, low byte shifted down 2
        outPixel.b=(u0u1.a*64.0)+(u0u1.r*.25);
        outPixel.r=(v0v1.a*64.0)+(v0v1.r*.25);
    }
    else
    {
        outPixel.g=(y0y1.g*64.0)+(y0y1.b*.25);  //high byte shifted up 6, low byte shifted down 2
        outPixel.b=(u0u1.g*64.0)+(u0u1.b*.25);
        outPixel.r=(v0v1.g*64.0)+(v0v1.b*.25);
    }

    gl_FragColor=outPixel;
}
